/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 *
 * This software is a multi-platform and portable application based on
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s
 * possible to calculate indicators «RhoMéO» to monitor quality,
 * fonctionalities and urban and agricultural pressures of wetlands.
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 *
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.protocol.p07;

import fr.cenra.rhomeo.api.annotations.RefersTo;
import fr.cenra.rhomeo.api.data.Statement;
import fr.cenra.rhomeo.api.data.Warning;
import fr.cenra.rhomeo.core.data.reference.Taxref;
import fr.cenra.rhomeo.protocol.validation.DeterminedSpecies;
import fr.cenra.rhomeo.protocol.validation.DifferenciableSpecies;
import java.util.Objects;
import java.util.function.Predicate;
import javafx.beans.property.IntegerProperty;
import javafx.beans.property.SimpleIntegerProperty;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;

/**
 *
 * @author Alexis Manin (Geomatys)
 */
public class P07Statement extends Statement {

    private final SimpleIntegerProperty cd_nomProperty = new SimpleIntegerProperty();

    private final SimpleIntegerProperty numberProperty = new SimpleIntegerProperty();

    @NotNull // Used for fx editor only
    @RefersTo(type = Taxref.class, property = "cd_nom", filterClass = AmphibianOnly.class)
    @DeterminedSpecies(payload=Warning.class)
    @DifferenciableSpecies
    public int getCd_nom() {
        return cd_nomProperty.get();
    }

    public void setCd_nom(final int newName) {
        cd_nomProperty.set(newName);
    }

    public IntegerProperty cd_nomProperty() {
        return cd_nomProperty;
    }

    @Min(1)
    public int getNumber() {
        return numberProperty.get();
    }

    public void setNumber(final int newNumber) {
        numberProperty.set(newNumber);
    }

    public IntegerProperty numberProperty() {
        return numberProperty;
    }

    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof P07Statement))
            return false;

        final P07Statement other = (P07Statement) obj;
        return getCd_nom() == other.getCd_nom() &&
                Objects.equals(getTrackingPoint(), other.getTrackingPoint()) &&
                Objects.equals(getDate(), other.getDate());
    }

    @Override
    public int hashCode() {
        int hash = 0;
        if (getTrackingPoint() != null)
            hash = 7 * hash + getTrackingPoint().hashCode();

        if (getDate() != null)
            hash = hash * 7 + getDate().hashCode();

        return hash * 7 + getCd_nom();
    }

    public static class AmphibianOnly implements Predicate<Taxref> {

        @Override
        public boolean test(Taxref t) {
            return "amphibia".equalsIgnoreCase(t.getClasse());
        }
    }
}
